﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Net.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.eShopOnContainers.WebMVC.Models;
using Microsoft.Extensions.Options;
using Newtonsoft.Json;
using Microsoft.eShopOnContainers.WebMVC.Services;
using Microsoft.eShopOnContainers.WebMVC.Models.HomeViewModels;

namespace Microsoft.eShopOnContainers.WebMVC.Controllers
{
    public class HomeController : Controller
    {
        private HttpClient _http;
        private AppSettings _settings;
        private ICatalogService _catalogSvc;

        public HomeController(IOptions<AppSettings> options, ICatalogService catalogSvc)
        {
            _http = new HttpClient();
            _settings = options.Value;
            _catalogSvc = catalogSvc;
        }
        public async Task<IActionResult> Index()
        {
            //var dataString = await _http.GetStringAsync(_settings.CatalogUrl);
            //var items = JsonConvert.DeserializeObject<List<CatalogItem>>(dataString);
            //items.AddRange(items);
            var items = await _catalogSvc.GetCatalogItems();
            var vm = new IndexViewModel()
            {
                CatalogItems = items
            };
            return View(vm);
        }

        public async Task<IActionResult> Orders()
        {
            ViewData["Message"] = "Orders page.";

            var ordersUrl = _settings.OrderingUrl + "/api/ordering/orders";
            var dataString = await _http.GetStringAsync(ordersUrl);
            var items = JsonConvert.DeserializeObject<List<Order>>(dataString);
            return View(items);
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
